#!/usr/bin/perl
#Adeel Mufti, 10/5/05

use strict;
use warnings;

use FindBin qw($Bin);
# from perlfaq5. 
use File::Temp qw/ tempfile tempdir /;

#  $dir = tempdir( CLEANUP => 1 );
#  ($fh, $filename) = tempfile( DIR => $dir );

#  # or if you don't need to know the filename

#  $fh = tempfile( DIR => $dir );

# with changes made by T. M. Murali on January 13, 2006.

###THESE NEED TO BE UPDATED on a new system###
my $PATH_TO_LAYOUT="/home/murali/bin.i686/layout";
my $PATH_TO_DRAWLAYOUT="/home/murali/bin.i686/drawlayout";
my $PATH_TO_TMP_DIR="/home/murali/public_html/tmp/bivoc/";
my $PATH_TO_UPLOAD_DIR="$PATH_TO_TMP_DIR/upload";
my $PATH_TO_TMP_DIR_WWW="/~murali/tmp/bivoc/";
my $PATH_TO_SAMPLE_BICLUSTER_FILE="$Bin/bivoc/examples/allaml/allaml-3.txt";
my $PATH_TO_SAMPLE_GENE_FILE="$Bin/bivoc/examples/allaml/ALL-AML-all-no-name.txt";
my $PATH_TO_SAMPLE_CLASS_FILE="$Bin/bivoc/examples/allaml/classConvert.txt";
my $PATH_TO_SAMPLE_LAYOUT_FILE="$PATH_TO_TMP_DIR/allaml-3.layout";

use CGI;

#setup all the data from the form input
my $query=new CGI;
my (%Form, $bf, $gf, $cf, $lf, $upload_filehandle);

$Form{uploaded}=$query->param("uploaded");
$Form{names}=$query->param("names");
$Form{search}=$query->param("search");
$Form{percent}=$query->param("percent");
$Form{biclusterFile}=$query->param("biclusterFile");
$Form{biclusterFile}=~s/.*[\/\\](.*)/$1/;
$Form{geneFile}=$query->param("geneFile");
$Form{geneFile}=~s/.*[\/\\](.*)/$1/;
$Form{classFile}=$query->param("classFile");
$Form{classFile}=~s/.*[\/\\](.*)/$1/;
$Form{genesOnWhichSide}=$query->param("genesOnWhichSide");
$Form{chop}=$query->param("chop");
$Form{noRows}=$query->param("noRows");
$Form{noColumns}=$query->param("noColumns");
$Form{sizeModifier}=$query->param("sizeModifier");

#if files are already uploaded, then use the path to these files passed by the previous instance of the script
if ((exists($Form{uploaded})) && (defined($Form{uploaded})) &&
    ($Form{uploaded} eq "1"))
{
  $bf=$query->param("bf");
  $gf=$query->param("gf");
  $cf=$query->param("cf");
  $lf=$query->param("lf");
}
elsif($Form{biclusterFile} && $Form{geneFile})
{
  $bf="$PATH_TO_UPLOAD_DIR/$Form{biclusterFile}";
  $gf="$PATH_TO_UPLOAD_DIR/$Form{geneFile}";
  $cf="$PATH_TO_UPLOAD_DIR/$Form{classFile}";
  $lf="$PATH_TO_UPLOAD_DIR/$Form{biclusterFile}.layout";

  #download file from the web browser uploading it
  $upload_filehandle = $query->upload("geneFile");
  open UPLOADFILE, ">$gf";
  binmode UPLOADFILE;
  while ( <$upload_filehandle> )
  {
    print UPLOADFILE;
  }
  close UPLOADFILE;

  #download file from the web browser uploading it
  $upload_filehandle = $query->upload("biclusterFile");
  open UPLOADFILE, ">$bf";
  binmode UPLOADFILE;
  while ( <$upload_filehandle> )
  {
    print UPLOADFILE;
  }
  close UPLOADFILE;

  #download file from the web browser uploading it
  if($Form{classFile})
  {
    $upload_filehandle = $query->upload("classFile");
    open UPLOADFILE, ">$cf";
    binmode UPLOADFILE;
    while ( <$upload_filehandle> )
    {
      print UPLOADFILE;
    }
    close UPLOADFILE;
  }
}
elsif(!$Form{biclusterFile} && !$Form{geneFile} && !$Form{classFile})
{
  #no files uploaded so use sample data
  $bf=$PATH_TO_SAMPLE_BICLUSTER_FILE;
  $gf=$PATH_TO_SAMPLE_GENE_FILE;
  $cf=$PATH_TO_SAMPLE_CLASS_FILE;
  $lf=$PATH_TO_SAMPLE_LAYOUT_FILE;
}
else
{
  print $query->header();
  print "
    <HTML>
    <HEAD>
    <TITLE>Oops</TITLE>
    </HEAD>
    Either you need to specify a Gene Expression file AND a Bicluster file or none at all!
    <BODY>
    </BODY>
    </HTML>";
    exit(1);
}

if((exists($Form{chop})) && (defined($Form{chop})) && 
   ($Form{chop} eq "true") && (!$Form{names}))
{
  print $query->header();
  print "
    <HTML>
    <HEAD>
    <TITLE>Oops</TITLE>
    </HEAD>
    You cannot ask to chop the image if you have not provided any search terms.
    <BODY>
    </BODY>
    </HTML>";
    exit(1);
}

#HEADER
print "Content-Type: text/html\r\n\r\n";
print "<html><head><title>Web Interface for Automatic Layout and Visualisation of Biclusters</title></head>\n";
print "<body>\n";

print $query->h1("Web Interface for Automatic Layout and Visualisation of Biclusters");


# print "<b>Valid gene-names/samples for this example are:</b> <br>\n";
# print "D26579_at, X59417_at, X74262_at, M34458_rna1_s_at, L28010_at, M92287_at, X15573_at, J03060_at, D89052_at, X52056_at, X95735_at, L09209_s_at<br>\n";
# print "44-ALL, 68-ALL, 24-ALL, 41-ALL, 4-ALL, 6-ALL, 7-ALL, 10-ALL, 11-ALL, 19-ALL, 3-ALL, 12-ALL, 14-ALL, 18-ALL, 21-ALL<br>\n";

print "<FORM ENCTYPE=\"multipart/form-data\" action=\"bivoc.cgi\" method=\"post\">";

print "Enter the name of one gene or one sample on each line. You do
not need to add any separators such as commas or semi-colons between
the names.<br>\n";

#output search terms if theyre already entered
if($Form{names}){
  print "<textarea name=\"names\" rows=\"8\" cols=\"50\">$Form{names}</textarea>\n";
}
else {
  print "<textarea name=\"names\" rows=\"8\" cols=\"50\"></textarea>\n";
}

print "<br>\n";

my ($or_checked, $and_checked, $percent_to_print);
#if its supposed to be an "and" or "or" search
if(!$Form{search} || ($Form{search} eq "or"))
  {
    $or_checked = "checked";
    $and_checked = "";
  }
else
  {
    $or_checked = "";
    $and_checked = "checked";
  }

if(!$Form{percent})
  {
    $percent_to_print = 100;
  }
else
  {
    $percent_to_print = $Form{percent};
  }

print "<INPUT type=\"radio\" name=\"search\" value=\"or\" $or_checked> Search for biclusters that contain either of these names.<BR>\n";
print "<INPUT type=\"radio\" name=\"search\" value=\"and\" $and_checked> Search for biclusters that contain at least ";
print("<INPUT type=\"text\" name=\"percent\" size=\"4\" value=\"",
	 $percent_to_print, "\"> ");
print("% of these names. \n");

my ($c, $r, $noRows, $noColumns, $sm, $rand, $name, @names, $count, $exec,
   $percent, $type, $x1, $y1, $x2, $y2, $x3, $y3, $x4, $y4);


#chose if theyre gonna be on left or right
if(!$Form{genesOnWhichSide} || ($Form{genesOnWhichSide} eq "left"))
{
  print "<br>\n";
  print "<INPUT type=\"radio\" name=\"genesOnWhichSide\" value=\"left\" checked> Print gene names on the left hand side.<BR>\n";
  print "<INPUT type=\"radio\" name=\"genesOnWhichSide\" value=\"right\"> Print gene names on the right hand side.<BR>\n";
}
else
{
  print "<br>\n";
  print "<INPUT type=\"radio\" name=\"genesOnWhichSide\" value=\"left\"> Show gene expression names on left hand side.<BR>\n";
  print "<INPUT type=\"radio\" name=\"genesOnWhichSide\" value=\"right\" checked> Show gene expression names on right hand side.<BR>\n";
  $r="-r";
}

print "<br>\n";
my ($chop_checked, $no_rows_checked, $no_columns_checked);

$chop_checked = "";
if ((exists($Form{chop})) and (defined($Form{chop})) and 
    ($Form{chop} eq "true"))
{
  $chop_checked = "checked";
}

print "<input type=\"checkbox\" name=\"chop\" value=\"true\" $chop_checked> Do not display biclusters that do not match any search terms. (Note: The image will be blank if no bicluster contains any of the search terms terms.)<br>\n";

print "<br>\n";

$noRows = "";
# $no_rows_checked = "";
# if($Form{noRows})
# {
#   $no_rows_checked = "checked";
#   $noRows="-noRows";
# }

# print "<input type=\"checkbox\" name=\"noRows\" value=\"true\" $no_rows_checked> Do not display any row names<br>\n";

$noColumns = "";
# if($Form{noColumns})
# {
#   $no_columns_checked = "checked";
#   $noColumns="-noColumns";
# }
# print "<input type=\"checkbox\" name=\"noColumns\" value=\"true\" $no_columns_checked> Do not display any column names<br>\n";


# print "<br>\n";


if(!$Form{sizeModifier})
{
  print "Size modifier: make image <INPUT type=\"text\" name=\"sizeModifier\" size=\"4\" value=\"1\"> times as big (can be a decimal value such as 1.5)<br>\n";
}
else
{
  print "Size modifier: make image <INPUT type=\"text\" name=\"sizeModifier\" size=\"4\" value=\"$Form{sizeModifier}\"> times as big (can be a decimal value such as 1.5)<br>\n";
  $sm="-sizeModifier $Form{sizeModifier}";
}

if (((defined($Form{biclusterFile})) && ($Form{biclusterFile}))
    || ((defined($Form{uploaded})) && ($Form{uploaded} eq "1")))
{
  #if files already uploaded, make hidden values so you can continue to use the path to these files
  print "<input type=\"hidden\" name=\"uploaded\" value=\"1\">\n";
  print "<input type=\"hidden\" name=\"bf\" value=\"$bf\">\n";
  print "<input type=\"hidden\" name=\"gf\" value=\"$gf\">\n";
  print "<input type=\"hidden\" name=\"lf\" value=\"$lf\">\n";
  print "<input type=\"hidden\" name=\"cf\" value=\"$cf\">\n";
  print "<input type=\"hidden\" name=\"geneFile\" value=\"$Form{geneFile}\">\n";
  print "<input type=\"hidden\" name=\"biclusterFile\" value=\"$Form{biclusterFile}\">\n";
  print "<br>Using gene exp file just uploaded: $Form{geneFile}<br>\n";
  print "Using bicluster file just uploaded: $Form{biclusterFile}<br>\n";
  if($Form{classFile})
  {
    print "Using class file just uploaded: $Form{classFile}<br>\n";
    print "<input type=\"hidden\" name=\"classFile\" value=\"$Form{classFile}\">\n";
  }
}
else
{
  print "<br><br><B>OPTIONAL (if none are uploaded then the default example files are used):</B>\n";
  print "<br> Bicluster File: <input type=\"file\" name=\"biclusterFile\" value=\"aaa\">\n";
  print "<br> Gene Exp. File: <input type=\"file\" name=\"geneFile\">\n";
  print "<br> Class File: <input type=\"file\" name=\"classFile\"> (this is optional)\n";
}

print "<br> <INPUT type=\"submit\" value=\"Submit\"> <INPUT type=\"reset\">
 </FORM>";

print "<hr>\n";

#basically makes a random image file name
$rand=rand();

#if there is a search being performed
if($Form{names})
{
  print "<br>Searching for the gene/sample names: <b>";

  #the following will split the search terms and put them in an array
  @names=split(/\n/,$Form{names});
  # remove names that match only whitespace.
  @names = grep { m/\S+/ } @names;
  $count = scalar(@names);
  print(join(", ", @names));
#   $count=0;
#   foreach $name (@names)
#   {
#     $name=`echo $name`; chop $name;
#     if($name eq '') { next; }
#     print "$name, \n";
#     $count++;
#   }
  print "</b> ...<br>\n";
#  print "</b> done in real time; please be patient...)<br>\n";

  #call layout
  $exec="$PATH_TO_LAYOUT -o $lf $bf";
  system($exec);
#  print("Exec is $exec.\n");
  
  #since class files are optional, these if/elses are needed
  if($Form{biclusterFile} && $Form{classFile}) { $c="-classes $cf"; }
  elsif(!$Form{biclusterFile}) { $c="-classes $cf"; }
  if($Form{chop} eq "true")
  {
    #call drawlayout so it can output the good biclusters first
    open(OUT,"|$PATH_TO_DRAWLAYOUT $sm $noColumns $noRows $r -search -t png -chop $PATH_TO_TMP_DIR/$rand\.bicluster -o $PATH_TO_TMP_DIR/$rand\.png -a $gf $c $lf");
    print OUT "$Form{search}\n";
    if($Form{search} eq 'and')
    {
      $percent=$Form{percent}/100;
      print OUT "$percent\n";
    }
    print OUT "$count\n";
    #output the search terms
    foreach $name (@names)
    {
      print OUT "$name\n";
    }
    close(OUT);

    #call layout on the new "good" bicluster file and then call drawlayout for the image again
    $exec= "$PATH_TO_LAYOUT -o $PATH_TO_TMP_DIR/$rand\.layout $PATH_TO_TMP_DIR/$rand\.bicluster";
    system($exec);
    open(OUT,"|$PATH_TO_DRAWLAYOUT $sm $noColumns $noRows $r -search -t png -o $PATH_TO_TMP_DIR/$rand\.png -a $gf $c $PATH_TO_TMP_DIR/$rand\.layout");
  }
  else
  {
    #no chop, just regular search
    open(OUT,"|$PATH_TO_DRAWLAYOUT $sm $noColumns $noRows $r -search -t png -o $PATH_TO_TMP_DIR/$rand\.png -a $gf $c $lf");
  }

  #This code is out here because OUT will always be opened either in the second instance of drawlayout if its
  #being chopped, or otherwise for regular searching without chopping. no need to put it inside each if/else
  print OUT "$Form{search}\n";
  if($Form{search} eq 'and')
  {
    $percent=$Form{percent}/100;
    print OUT "$percent\n";
  }
  print OUT "$count\n";
  foreach $name (@names)
  {
    print OUT "$name\n";
  }
  close(OUT);

}
else
{
  #no search terms provided
  $exec="$PATH_TO_LAYOUT -o $lf $bf";
  print("Running command: $exec <BR>");
  system($exec);
  
#   print("PWD is ", 
# 	   join("<br>", map {$_, ": ", $ENV{$_}} sort keys %ENV), 
# 	   "<br>");
  
  
  $exec="$PATH_TO_DRAWLAYOUT $sm $noRows $noColumns $r -t png -o $PATH_TO_TMP_DIR/$rand\.png -a $gf -classes $cf $lf";
  print("Running command: $exec <BR>");
  system($exec);
  
}

#read from the image map file provided by drawlayout so we can map images
#NOTE: The correct URL needs to be determined for each gene/sample name
# print "<map name=\"bicluster\">\n";
# open(MAP,"$rand.png.map");
# while(<MAP>)
# {
#   chop $_;
#   if(/(.*?)\:(.*)/) { 
#     if($1 eq "r")
#     {
#       ($type,$name,$x1,$y1,$x2,$y2)=split(/:/,$_);
#       print "<area shape=\"rect\" coords=\"$x1,$y1,$x2,$y2\" href=\"http://path/to/$name\.html\">\n";
#     }
#     else
#     {
#       ($type,$name,$x1,$y1,$x2,$y2,$x3,$y3,$x4,$y4)=split(/:/,$_);
#       print "<area shape=\"poly\" coords=\"$x1,$y1,$x2,$y2,$x3,$y3,$x4,$y4\" href=\"http://path/to/$name\.html\">\n";
#     }
#   }
# }
# print "</map>\n";

#print the image
print "<br>Image:<br>\n";
print "<img src=\"$PATH_TO_TMP_DIR_WWW/$rand.png\" usemap=\"#bicluster\" border=0>\n";

#print notes
# print "<br><br><br>\n";
# print "<b><u>Here are some notes/todo lists:</u></b><br>\n";
# open(NOTES,"notes.txt");
# while($in=<NOTES>)
# {
#   chop $in;
#   print "$in<br>\n";
# }
# close(NOTES);

print "</body></html>\n";
print "\r\n\r\n";

